<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="打卡人姓名" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入打卡人姓名"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="班组名称" prop="teamName">
        <el-input
          v-model="queryParams.teamName"
          placeholder="请输入班组名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="主管名称" prop="departmentName">
        <el-input
          v-model="queryParams.departmentName"
          placeholder="请输入主管名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="打卡日期">
        <el-date-picker
          clearable
          v-model="dateRange"
          value-format="YYYY-MM-DD"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="打卡类型" prop="checkInType">
        <el-select
               v-model="queryParams.checkInType"
               placeholder="打卡类型"
               clearable
               style="width: 240px"
            >
               <el-option
                  v-for="dict in attendance_check_in_type"
                  :key="dict.value"
                  :label="dict.label"
                  :value="dict.value"
               />
            </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['attendance:checkRecord:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="checkRecordList" @selection-change="handleSelectionChange">
      <el-table-column label="打卡人姓名" align="center" prop="userName" />
      <el-table-column label="班组名称" align="center" prop="teamName" />
      <el-table-column label="主管名称" align="center" prop="departmentName" />
      <el-table-column label="打卡类型" align="center" prop="checkInTypeDesc" />
      <el-table-column label="打卡时间" align="center" prop="checkInTime" />
      <el-table-column label="备注" align="center" prop="remark" />
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改打卡记录对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="checkRecordRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="租户号" prop="tenantId">
          <el-input v-model="form.tenantId" placeholder="请输入租户号" />
        </el-form-item>
        <el-form-item label="乐观锁" prop="revision">
          <el-input v-model="form.revision" placeholder="请输入乐观锁" />
        </el-form-item>
        <el-form-item label="打卡人ID" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入打卡人ID" />
        </el-form-item>
        <el-form-item label="打卡时间" prop="checkInTime">
          <el-date-picker clearable
            v-model="form.checkInTime"
            type="date"
            value-format="YYYY-MM-DD"
            placeholder="请选择打卡时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="打卡人名称" prop="userName">
          <el-input v-model="form.userName" placeholder="请输入打卡人名称" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="打卡类型名称" prop="checkInTypeDesc">
          <el-input v-model="form.checkInTypeDesc" placeholder="请输入打卡类型名称" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="CheckRecord">
import { listCheckRecord, getCheckRecord, delCheckRecord, addCheckRecord, updateCheckRecord } from "@/api/attendance/checkRecord"

const { proxy } = getCurrentInstance()

const checkRecordList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")
const dateRange = ref([])
const { attendance_check_in_type } = proxy.useDict("attendance_check_in_type")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    tenantId: null,
    revision: null,
    userId: null,
    checkInType: null,
    checkInTime: null,
    userName: null,
    remark: null,
    checkInTypeDesc: null
  },
  rules: {
    userId: [
      { required: true, message: "打卡人ID不能为空", trigger: "blur" }
    ],
    checkInType: [
      { required: true, message: "打卡类型不能为空", trigger: "change" }
    ],
    checkInTime: [
      { required: true, message: "打卡时间不能为空", trigger: "blur" }
    ],
    userName: [
      { required: true, message: "打卡人名称不能为空", trigger: "blur" }
    ],
    checkInTypeDesc: [
      { required: true, message: "打卡类型名称不能为空", trigger: "blur" }
    ]
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询打卡记录列表 */
function getList() {
  loading.value = true
  listCheckRecord(proxy.addDateRange(queryParams.value, dateRange.value)).then(response => {
    checkRecordList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    tenantId: null,
    revision: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    id: null,
    userId: null,
    checkInType: null,
    checkInTime: null,
    userName: null,
    remark: null,
    checkInTypeDesc: null
  }
  proxy.resetForm("checkRecordRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  dateRange.value = []
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加打卡记录"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getCheckRecord(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改打卡记录"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["checkRecordRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateCheckRecord(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addCheckRecord(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除数据项？').then(function() {
    return delCheckRecord(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('attendance/checkRecord/export', {
    ...queryParams.value
  }, `checkRecord_${new Date().getTime()}.xlsx`)
}

getList()
</script>
